/* THIS FILE IS TO OBTAIN THE CRITICAL GANMA FOR T>0. 
For THE CASE OF T=0 LOOK AT 2RS.PRG   
 */

new;
library optmum;
#include optmum.ext;
#include hessian.src;
#include anneal.src;

output file = cgln_007sa_bis.out reset;
@ ------------ User Parameters ------------------@
t=0.07;
r=10;
pb=0.8;
pg=0.2;
rho=0.5;
satol=1e-16;
_opgtol=1e-12;

flag2=0;
theta2=0;
inigam=0.60; @initial ganma@
fingam=1; @final ganma@

/* Uncomment this For U=ln(t) */

fn util(t)=ln(t);  @Utility function@

fn invu(t)=exp(t); @Inverse of the utility function@

fn deru(t)=1/t;    @Derivative of the utility function@

fn derinvut(t)=exp(t); @Derivative of the inverse of the utility@

fn secder(t)=-1/(t^2);  @Second derivative of utility function@                   



/* For SQRT  

fn util(t)=sqrt(t);  @Utility function@

fn invu(t)=t^2; @Inverse of the utility function@

fn deru(t)=1/(2*sqrt(t));    @Derivative of the utility function@

fn derinvut(t)=2*t; @Derivative of the inverse of the utility@ 

fn secder(t)=-1/(4*t^1.5); @Second derivative of utility function@ */

/* For 2x-x^2 

fn util(t)=2*t-t^2; @utility function@

fn invu(t)=(2+sqrt(4-4*t))/2; @Inverse of utility. We take the positive branch@

fn deru(t)=2-2*t; @Derivative of utility@

fn derinvut(t)=-1/sqrt(4-4*t); @derivative of inverse of utility@

fn secder(t)=-2;

*/
@------------- User, do not touch ---------------@
"THIS PROGRAM IS TO OBTAIN THE OPTIMAL GANMA WHEN T>0 ";
"IT ONLY CHECKS FOR DEVIATION THAT ASSUMES ICCB BINDING ";
"IT ONLY CHECKS FOR DEVIATIONS THAT ASSUME THAT CONTRACT FOR BAD IS BINDING ";
"---------------------------------------------------------------";
"---------------------------------------------------------------";
"------------------- Parameter Values --------------------------";
temp1={ t,r,pb,pg,rho };
temp2=t|r|pb|pg|rho;
call presen2(temp1,temp2);
"Tolerance for Optmum";;_opgtol;
"Simulated Annealing Tolerance ";;satol;

/* STARTS LOOP FOR DIFFERNT GAMMAS */
gam=0;
inc=0.01;
do until gam ge fingam;
gam=inigam+inc;
inigam=gam;

/*************************** OPTIMIZATION *****************************/
flag=0;
_opalgr=2;
__output=0;

initheta=7|7;



/* {theta,f,g,retcode}=optprt(optmum(&separ,initheta));
*/
/*
{theta,f,g,retcode}=qnewton(&separ,initheta);
*/
ub={ 12, 12 };
lb={ 0, 0 };
initemp=15;
{theta, f, nacc, nfcnev, nobds, ier, temper, vm} =
     sa (&separ,initheta,0,0.85,satol,20,100,4,1e+8,lb,ub,2|2,0,initemp,5|5);

/************** Checking the result of the minimization **************/
/*
if retcode ne 0;
   "***********************************************************************
   Retcode is different from zero. It is";;retcode;
   goto final;
   endif;
Hessiano=hessian(&separ,theta);
call hessana(hessiano,-1,0);
*/
"";
"";
sem0g=theta[1];
sen0g=theta[2];
sen0b=rest2(sem0g,sen0g,pb);
sem0b=sen0b;
temp1={ m0g, n0g, m0b, n0b };
temp2=sem0g|sen0g|sem0b|sen0b;
"*****************************************************************************";
"*****************************************************************************";
"******************************************************************************";
"Current gamma ";;gam;
"";
"--------- The results of the separating candidate at current ganma ----------";
call presen2(temp1,temp2);
"Good risk profit per capita ";;prof(sem0g,sen0g,pg);
"Bad risk progit per capita ";;prof(sem0b,sen0b,pb);
"The Value of the FOC evaluated at the optimum are ";

dm0gS(sem0g,sen0g,sem0g,sen0g);
dn0gS(sem0g,sen0g,sem0g,sen0g);
format /mb1 /ros 16,16;
{ exprose }=exprofit(sem0g,sen0g,sem0b,sen0b,sem0g,sen0g,sem0b,sen0b);
"The expected profits in separating equilibria are ";;exprose;
UBb=exputil(sem0b,sen0b,pb);
UBg=exputil(sem0g,sen0g,pb);
UGg=exputil(sem0g,sen0g,pg);
UGb=exputil(sem0b,sen0b,pg);
"";
temp1= { UBb, UBg, UGg, UGb };
temp2=Ubb|ubg|ugg|ugb;
"Utilities in the separating are ";;
call presen2(temp1,temp2);
"UKJ means utility of type K when choose contract for J";

/********* Checking Concatity of Pi*Demand at the point **********/
"";
"If the following numbers are positive, the function Profits*Demand is
concave in the candidate";
"Good  ";;conca(sem0b,sen0b,pg);
"Bad   ";;conca(sem0b,sen0b,pb);
"";

/* The following checks that the separating best response to the 
candidate, it is the candidate itself , given that ICCB Binding */

"--------- COMPUTING SEPARATING BEST RESPONSES -----------------------";

flag=1;        @ To allow for m,n that yield demands outside 0,1 @
if flag2==0;
initheta=7|7;
else;
initheta=theta2;
endif;
flag2=1;

@We impose ICCB binding
It restrics demand to be between 0 and 1
It assumes that the contract for the bad type is efficient@
ub={ 12, 12 };
lb={ 0, 0 };
rt=0.9;
{theta2, f, nacc, nfcnev, nobds, ier, temper, vm} =
     sa (&bestres1,initheta,1,rt,satol,20,100,4,1e+8,lb,ub,2|2,0,initemp,5|5);

m0g=theta2[1];
n0g=theta2[2];
m0b=rest2(m0g,n0g,pb);
n0b=m0b;
temp1={ m0g, n0g, n0b, m0b };
temp2=m0g|n0g|n0b|m0b;
"Final Vm ";
Vm';
"Best Responses are ";;
call presen2(temp1,temp2);
"";
"Which yield profits ";;f;

"Diference of profits between Candidate and Best Response";
"Candidate - Best Response profit= ";;exprose-f;

"";
UBb=exputil(m0b,n0b,pb);
UBg=exputil(m0g,n0g,pb);
UGg=exputil(m0g,n0g,pg);
UGb=exputil(m0b,n0b,pg);
"";
temp1= { UBb, UBg, UGg, UGb };
temp2=Ubb|ubg|ugg|ugb;
"Utilities in the deviating are ";;
call presen2(temp1,temp2);
"";
dempolb=demand(m0b,n0b,sem0b,sen0b,pb);
dempolg=demand(m0g,n0g,sem0g,sen0g,pg);
"Deviating firm, demand BAD ";;dempolb;
"Deviating firm, demand GOOD ";;dempolg;
"";
flag=0;
endo;
end;

/* The following checks that the separating best response to the 
candidate, it is the candidate itself , given that ICCG Binding */

flag=1;        @ To allow for m,n that yield demands outside 0,1 @

"The following computes the best response to the separating candidate.
,using an algorithm that looks for global optima";
"We impose ICCG binding";
"It restrics demand to be between 0 and 1 ";
"It assumes that the contract for the Good type is efficient";
ub={10, 10 };
lb={ 0, 0 };
{theta, f, nacc, nfcnev, nobds, ier, temper, vm} =
     sa (&bestres2,initheta,1,0.85,satol,20,100,4,1e+8,lb,ub,2|2,0,10,3|3);

m0b=theta[1];
n0b=theta[2];
m0g=rest2(m0b,n0b,pg);
n0g=m0g;
temp1={ m0g, n0g, n0b, m0b };
temp2=m0g|n0g|n0b|m0b;
"Final Vm ";
Vm';
"Best Responses are ";;
call presen2(temp1,temp2);
"";
"Which yield profits ";;f;
"";
"Which yield profits ";;f;
if f .> exprose;
"******** WARNING, SEPARATING CANDIDATE IS BROKEN *******";
ELSEIF f .le EXPROSE;
"******** CHACHI,  SEPARATING CANDIDATE SURVIVES";
ELSE;
"FAlILURE";
ENDIF;
"";
UBb=exputil(m0b,n0b,pb);
UBg=exputil(m0g,n0g,pb);
UGg=exputil(m0g,n0g,pg);
UGb=exputil(m0b,n0b,pg);
"";
temp1= { UBb, UBg, UGg, UGb };
temp2=Ubb|ubg|ugg|ugb;
"Utilities in the deviating are ";;
call presen2(temp1,temp2);
"";
dempolb=demand(m0b,n0b,sem0b,sen0b,pb);
dempolg=demand(m0g,n0g,sem0g,sen0g,pg);
"Deviating firm, demand BAD ";;dempolb;
"Deviating firm, demand GOOD ";;dempolg;
"Warning, this figures above assume that the contract is Incentive Compatible";
"";

/********* Computing the optimal pooling deviation ********************/
"-----------ANALYSING OPTIMAL POOLING DEVIATION----------------------";
"We use an algorithm that looks for global optima";
"It restrics demand to be between 0 and 1 ";
initheta=5.5|3.5;
flag=1;
/*
{theta,nf,g,retcode}=optprt(optmum(&desvpol,initheta));
*/

/* use this one */ 
/* "This one uses BFGS ";
 {theta,nf,g,retcode}=qnewton(&desvpol,initheta); 
*/

flag=1;
ub={10, 10 };
lb={ 0, 0 };
"This one uses SA method ";
{theta, nf, nacc, nfcnev, nobds, ier, temper, vm} =
     sa (&desvpol,initheta,0,0.85,satol,20,100,4,1e+8,lb,ub,2|2,0,10,3|3);


/*
/************** Checking the result of the minimization **************/

if retcode ne 0;
   "***********************************************************************
   Retcode is different from zero. It is";;retcode;
   goto final;
   endif;
*/

Hessiano=hessian(&desvpol,theta);
call hessana(hessiano,-1,0);

"Given that the firm 1 plays the separating candidate, the optimal
pooling desviation for firm 0 is to play (M,N)";theta';
cls;

/* Here I compute the demand that the deviating firm have */
flag=1;

dempolb=demand(theta[1],theta[2],sem0b,sen0b,pb);
dempolg=demand(theta[1],theta[2],sem0g,sen0g,pg);

devprof=-nf;

UBbp=exputil(theta[1],theta[2],pb);
UGgp=exputil(theta[1],theta[2],pg);

"";
temp1= { UBb, UGg };
temp2=Ubbp|uggp;
"Utilities for consumers going to the the deviating firm is ";;
call presen2(temp1,temp2);
"";

"Bad type deviating pooling demand ";;dempolb;
"Good type deviating pooling demand ";;dempolg;

"";
"Bad type deviating profits per capita ";;prof(theta[1],theta[2],pb);
"Good type deviating profits per capita ";;prof(theta[1],theta[2],pg);
"Deviating profits ";;devprof;

if devprof .> exprose;
"******** WARNING, POOLING BREAKS SEPARATING*******";
ELSEIF devprof .le EXPROSE;
"******** CHACHI,  SEPARATING SURVIVES TO POOLING";
ELSE;
"FAILURE";
ENDIF;

/**************************** PROCEDURES ******************************/
/* Expected Utility */
proc exputil(m,n,p);
local um,un;
um=util(m);
un=util(n);
retp(um+p*un);
endp;

/* Function to compute optimal
pooling deviation */

proc desvpol(A);
local exprose2,M,N;
M=A[1];
N=A[2];
{ exprose2 }=exprofit(m,N,m,N,sem0g,sen0g,sem0b,sen0b); @Notice, this is @
                                                       @given the separating candidate@
retp(-exprose2);
endp;


/* Expected profit function */
proc exprofit(m0g,n0g,m0b,n0b,m1g,n1g,m1b,n1b);
local a,b;
a=gam*prof(m0g,n0g,pg)*demand(m0g,n0g,m1g,n1g,pg);
b=(1-gam)*prof(m0b,n0b,pb)*demand(m0b,n0b,m1b,n1b,pb);
retp(a+b);
endp;

/* Expected profit to compute if the best response to the
candidate is the candidate or not, given that ICCB binding */

proc bestres1(theta);
local m0g,n0g,n0b,m0b,a,b,ugg,ugb;
m0g=theta[1];
n0g=theta[2];

{ m0b }=rest2(m0g,n0g,pb); @Bad type is efficient@
n0b=m0b;
@Notice, sem0g...is the candidate. This is given @

@The ICCB is binding for sure, due to the constraint above.
The machine could search in places where the ICCG of the Good
is not verified. In this case, the relevant demand and profit
comes from the contract for the bad @

UGG=exputil(m0g,n0g,pg);
UGB=exputil(m0b,n0b,pg);

if UGG ge UGB; @ICCG is verifires@

    a=gam*prof(m0g,n0g,pg)*demand(m0g,n0g,sem0g,sen0g,pg);
    b=(1-gam)*prof(m0b,n0b,pb)*demand(m0b,n0b,sem0b,sen0b,pb);
    retp(a+b);

else; @ICCG is not@
 
    a=gam*prof(m0b,n0b,pg)*demand(m0b,n0b,sem0g,sen0g,pg);
    b=(1-gam)*prof(m0b,n0b,pb)*demand(m0b,n0b,sem0b,sen0b,pb);
    retp(a+b);   

endif;

endp;


/* Expected profit to compute if the best response to the
candidate is the candidate or not, given that ICCG binding */

proc bestres2(theta);
local m0g,n0g,n0b,m0b,a,b,ugg,ugb;
m0b=theta[1];
n0b=theta[2];

{ m0g }=rest3(m0b,n0b,pg); @Bad type is efficient@
n0g=m0g;
@Notice, sem0g...is the candidate. This is given @

@The ICCG is binding for sure, due to the constraint above.
The machine could search in places where the ICC of the Bad
is not verified. In this case, the relevant demand and profit
comes from the contract for the bad @

UBB=exputil(m0b,n0b,pb);
UBG=exputil(m0g,n0g,pb);

if UBB ge UBG; @ICCB is verifires@

    a=gam*prof(m0g,n0g,pg)*demand(m0g,n0g,sem0g,sen0g,pg);
    b=(1-gam)*prof(m0b,n0b,pb)*demand(m0b,n0b,sem0b,sen0b,pb);
    retp(a+b);

else; @ICCB is not@
 
    a=gam*prof(m0g,n0g,pg)*demand(m0g,n0g,sem0g,sen0g,pg);
    b=(1-gam)*prof(m0g,n0g,pb)*demand(m0g,n0g,sem0b,sen0b,pb);
    retp(a+b);   

endif;

endp;

/* Procedure that computes sum of the first order
condition at square, in order to solve the separting
symmetric equilibrium                               */

proc separ(a);
local m0g,n0g,n0b,m0b,sl1,sl2;

m0g=a[1];
n0g=a[2];


@Now we compute the derivatives of the expected profit@
@Notice, they are evaluated at symmetric equilibria @

sl1=dm0gS(m0g,n0g,m0g,n0g);
sl2=dn0gS(m0g,n0g,m0g,n0g);


retp(sl1^2+sl2^2);
endp;


/* Given a probability (p) and mg, ng nb of a whatever firm (0,1),
this procedure returns mb that verifies the ICC */

proc rest(nb,mg,ng,p);
local mb;
mb=invu(util(mg)+p*util(ng)-p*util(nb));
retp(mb);
endp;

/* Given pb, m0g and n0g, it computes the contract
(alpha,alpha) which leaves the ICCB binding */
proc rest2(mg,ng,pb);
local a;
a=invu((util(mg)+pb*util(ng))/(1+pb));
retp(a);
endp;

/* Given pg, m0b and n0b, it computes the contract
(alpha,alpha) which leaves the ICCG binding */
proc rest3(mb,nb,pg);
local a;
a=invu((util(mb)+pg*util(nb))/(1+pg));
retp(a);
endp;

/* This procedure gives the profits per type */

proc prof(m,n,p);
retp (r-m-p*n);
endp;

/* This procedure gives the Demand per type */
/* It gives the demand for the firm with (mbi,nbi) */ 
 
proc demand(mbi,nbi,mbj,nbj,p);
local dt;
dt=util(mbi)+p*util(nbi)-util(mbj)-p*util(nbj)+t;
dt=dt/(2*t);

if flag==0;

retp(dt);

else;
retp(0*(dt le 0)+dt*( dt gt 0)*(dt lt 1)+1*(dt ge 1)); 
endif;
endp;

/* This procedure gives the Derivative of 
the Expected profit wrt m0g. No constraint imposed */

proc dm0g(m0g,n0g,m1g,n1g,n0b);
local r1,a,r2,r,m0b;
a=util(m0g)+pb*util(n0g)-pb*util(n0b);
m0b=rest(n0b,m0g,n0g,pb);              @Obtaining m0b from restriction@
r1=-gam*demand(m0g,n0g,m1g,n1g,pg);
r1=r1+gam*prof(m0g,n0g,pg)*deru(m0g)/(2*t);
r2=-(1-gam)*derinvut(a)*deru(m0g)*demand(m0b,n0b,m0b,n0b,pb);
r2=r2+(1-gam)*prof(m0b,n0b,pb)*deru(m0g)/(2*t);
r=r1+r2;
retp(r);
endp;

/* This procedure gives the Derivative of 
the Expected profit wrt n0g. No constraint imposed */

proc dn0g(m0g,n0g,m1g,n1g,n0b);
local r1,a,r2,r,m0b;
a=util(m0g)+pb*util(n0g)-pb*util(n0b);
m0b=rest(n0b,m0g,n0g,pb);              @Obtaining m0b from restriction@
r1=-pg*gam*demand(m0g,n0g,m1g,n1g,pg);
r1=r1+pg*gam*prof(m0g,n0g,pg)*deru(n0g)/(2*t);
r2=-(1-gam)*pb*derinvut(a)*deru(n0g)*demand(m0b,n0b,m0b,n0b,pb); @symmetry@
r2=r2+(1-gam)*prof(m0b,n0b,pb)*pb*deru(n0g)/(2*t);
r=r1+r2;
retp(r);
endp;

/* This procedure gives the Derivative of 
the Expected profit wrt n0b. No constraint imposed */

proc dn0b(m0g,n0g,n0b,n1b);
local a,r1,r2,m0b;
{ m0b }=rest(n0b,m0g,n0g,pb);              @Obtaining m0b from restriction@
r1=-pb*(1-gam)*demand(m0b,n0b,m0b,n1b,pb); @symmetry@
a=util(m0g)+pb*util(n0g)-pb*util(n0b);
r2=pb*(1-gam)*derinvut(a)*deru(n0b)*demand(m0b,n0b,m0b,n1b,pb); @symmetry@
retp(r1+r2);
endp;






/* This procedure gives the Derivative of 
the Expected profit wrt m0g. Symmetry is imposed. 
Bad type efficient is imposed */

proc dm0gS(m0g,n0g,m1g,n1g);
local r1,a,r2,r,m0b,n0b;

{ m0b }=rest2(m0g,n0g,pb);              @Obtaining m0b from restriction@
n0b=m0b;
a=util(m0g)+pb*util(n0g)-pb*util(n0b);
r1=-gam*0.5; @symmetry@
r1=r1+gam*prof(m0g,n0g,pg)*deru(m0g)/(2*t);
r2=-(1-gam)*derinvut(a)*deru(m0g)*0.5; @symmetry@
r2=r2+(1-gam)*prof(m0b,n0b,pb)*deru(m0g)/(2*t);
r=r1+r2;
retp(r);
endp;

/* This procedure gives the Derivative of 
the Expected profit wrt n0g. Symmetry is imposed.
Bad type efficiency is imposed */

proc dn0gS(m0g,n0g,m1g,n1g);
local n0b,r1,a,r2,r,m0b;

{ m0b }=rest2(m0g,n0g,pb);              @Obtaining m0b from restriction@
n0b=m0b;
a=util(m0g)+pb*util(n0g)-pb*util(n0b);
r1=-pg*gam*0.5; @symmetry@
r1=r1+pg*gam*prof(m0g,n0g,pg)*deru(n0g)/(2*t);
r2=-(1-gam)*pb*derinvut(a)*deru(n0g)*0.5; @symmetry@
r2=r2+(1-gam)*prof(m0b,n0b,pb)*pb*deru(n0g)/(2*t);
r=r1+r2;
retp(r);
endp;

/* This procedure gives the Derivative of 
the Expected profit wrt n0b. Symmetry is imposed */

/* THIS FOC IS NOT NECESARY, ONCE BAD TYPE EFFICIENCY 
IS IMPOSED */

proc dn0bS(m0g,n0g,n0b,n1b);
local a,r1,r2,m0b;
{ m0b }=rest(n0b,m0g,n0g,pb);              @Obtaining m0b from restriction@
r1=-pb*(1-gam)*0.5; @symmetry@
a=util(m0g)+pb*util(n0g)-pb*util(n0b);
r2=pb*(1-gam)*derinvut(a)*deru(n0b)*0.5; @symmetry@
retp(r1+r2);
endp;


/******* These procedures are to check concavity condition ************/
proc conca(m,n,p);
local prof,a,b;
prof=r-m-n*p;
a=-2*deru(m)*secder(n)-2*secder(m)*deru(n)*p+prof*secder(m)*secder(n);
b=a*prof-p*(deru(m)-deru(n))^2;
retp(b);
endp;





proc presen2(varnames,coef);
local fmt,mask,results;
fmt={ "- *.*lg" 10 10,
      "*.*lf" 16 16 };
mask={ 0,1 };
mask=mask';
cls;

print;
print "Name        Values";
print "____________________";
results=varnames~coef;
call printfm(results,mask,fmt);
retp(0);
print;
endp;


/* ***************************************************************************

This program analyse a given Hessian to obtain diagnosis related to convergence

******************************************************************************/

proc(0)=hessana(H,a,b);
/*
H=Hessian.
a=+1, if the Hessian is the result of a maximization
  -1, if the Hessian is the result of a minimization

b=1, if you require analysis of dependencies among columns
b=0, if you only require eigenvalue analysis.        */

local myeig,condnum,r,e;

myeig=eig(H);
condnum=maxc(myeig)/minc(myeig);
@
"";
"The eigenvalues are";
"";
myeig';
@
"";
if a==-1 and minc(real(myeig)) > 0;
"Eigenvalues with right sign";
"";
@
"The closer the condition number is to 1, the better your hessian";
"Condition number is ";;condnum;
"So when inverting, the number of decimal places you lose is ";
log(condnum);
@
endif;
if a==-1 and minc(real(myeig)) < 0;
"Eigenvalues with wrong sign";
"";
endif;
if a==1 and maxc(real(myeig)) < 0;
"Eigenvalues with right sign";
@
"The closer the condition number is to 1, the better your hessian";
"Condition number of the hessian is";;condnum;
"So when inverting, the number of decimal places you lose is ";
log(condnum);
@
endif;
if a==1 and maxc(real(myeig)) > 0;
"Eigenvalues with wrong sign";
endif;

if b==1;
"";
"****************************************************************************";
"  The diagonal of the R matrix is the following. The number of elements     ";
" close to zero are the number of linear dependent colums                    ";
"****************************************************************************";

"";
{R,e}=qre(H);
diag(R);
endif;
endp;


FINAL:
output off;
end;